#include <dspi.h>
#include <stdio.h>
#include <conio.h>
#include <io.h>
#include <dir.h>
#include <alloc.h>

#ifdef __DPMI32__
	#define  CONFIG   "MIDI32.CFG"
	#define  DRV      "..\\32BIT"
#elif defined(__DPMI16__)
	#define  CONFIG   "MIDI16.CFG"
	#define  DRV      "..\\16BIT"
#else
	#define  CONFIG   "MIDI.CFG"
	#define  DRV      "..\\REAL"
#endif

LPBYTE GetConfigString (void);

void main (int argc, char** argv) {
	if (argc != 2) {
		printf ("Usage: PLAYSCOR scorname\n");
		return;
	}

	LPBYTE lpString = GetConfigString();
	if ( lpString == NULL ) {
		printf ("ERROR: Unable to load file %s\n", CONFIG);
		return;
	}

	chdir(DRV);
	if ( midiLoadDriver((LPSTR)lpString) != MIDI_ERROR_NONE ) {
		printf ("ERROR: Unable to load driver %s\n", lpString);
		chdir ("..");
		return;
	}
	chdir ("..\\BIN");
	midiSetDriverSpecific ( lpString + 13 );
	if ( midiDriverEntry() != MIDI_ERROR_NONE ) {
		printf ("ERROR: Cannot initialize driver\n");
		return;
	}

	if ( midiLoadScore ( argv[1] ) != MIDI_ERROR_NONE ) {
		printf ("ERROR: Unable to load score %s\n", argv[1] );
		return;
	}

	clrscr();
	for (int n = 0; n < midiHowManySequences(); n++) {
		midiPlaySequence(n, MIDI_LAST);
	}

	printf ("Score playing\n");

	do {
		if ( kbhit() ) {
			getch();
			midiFadeOut (4);
		}
	} while ( midiGetStatus() != MIDI_STOPPED );

	printf ("Stopped.  Have a nice day.\n");

	midiCloseDriver();
}

LPBYTE GetConfigString (void) {
	FILE *fp;
	fp = fopen (CONFIG, "rb");
	if (fp == NULL) {
		return NULL;
	}
	DWORD dwLen = filelength(fileno(fp));
	LPBYTE file = (LPBYTE)farmalloc(dwLen + 1);
	fread (file, 1, (WORD)dwLen, fp);
	fclose (fp);
	return file;
}

